/**
 * OWASP CSRFTester
 * 
 * This file is part of the Open Web Application Security Project (OWASP)
 * Copyright (c) 2007 - The OWASP Foundation
 * 
 * The CSRFTester is published by OWASP under the LGPL. You should read and accept the
 * LICENSE before you use, modify, and/or redistribute this software.
 * 
 * @author <a href="http://www.aspectsecurity.com">Aspect Security</a>
 * @created 2007
 */

package org.owasp.csrftester.report;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.owasp.csrftester.CSRFTesterModel;

public final class LinkReport extends ReportAdapter
{
	protected LinkReport()
	{
		
	}
	
	public String generateHtml(CSRFTesterModel model, File dir) throws IOException
	{
		String html = getLinkHtml(model);
		String content = getContent("/resources/LinkTemplate.html");
		
		content = content.replace("<%LINK%>", html);
		writeFile(dir, "index.html", content);
    	return "file://" + dir.getPath() + "/index.html";
	}
	
	private String getLinkHtml(CSRFTesterModel model)
	{
		String url = model.getURL(0);
		String parameters = model.getParameters(0);
		String linkText = model.getLinkText();
		StringBuffer sb = new StringBuffer();
		
		sb.append("<a href=\"");
		sb.append(model.getURL(0));
		
		if(url.indexOf('?') != -1)
		{
			sb.append('&');
			sb.append(parameters);
		}
		else
		{
			sb.append('?');
			sb.append(parameters);
		}
		
		sb.append("\"/>");
		sb.append(linkText);
		sb.append("</a>");
		return sb.toString();
	}
}
